summaryrefslogtreecommitdiff
path: root/build
diff options
context:
space:
mode:
authorLeah Rowe <leah@libreboot.org>2024-03-27 01:19:39 +0000
committerLeah Rowe <leah@libreboot.org>2024-03-27 01:50:31 +0000
commit6ebab10caa5be6fc1cfd244e745851687d4bd70d (patch)
tree0b983459c0cbc1b8998186975f9a571decb05592 /build
parent6b11f1b055466982747f65665506173a0b22557b (diff)
safer, simpler error handling in lbmk
in shell scripts, a function named the same as a program included in the $PATH will override that program. for example, you could make a function called ls() and this would override the standand "ls". in lbmk, a part of it was first trying to run the "fail" command, deferring to "err", because some scripts call fail() which does some minor cleanup before calling err. in most cases, fail() is not defined, and it's possible that the user could have a program called "fail" in their $PATH, the behaviour of which we could not determine, and it could have disastrous effects. lbmk error handling has been re-engineered in such a way that the err function is defined in a variable, which defaults to err_ which calls err_, so defined under include/err.sh. in functions that require cleanup prior to error handling, a fail() function is still defined, and err is overridden, thus: err="fail" this change has made xx_() obsolete, so now only x_ is used. the x_ function is a wrapper that can be used to run a command and exit with non-zero status (from lbmk) if the command fails. the xx_ command did the same thing, but called fail() which would have called err(); now everything is $err example: rm -f "$filename" || err "could not delete file" this would now be: rm -f "$filename" || $err "could not delete file" overriding of err= must be done *after* including err.sh. for example: err="fail" . "include/err.sh" ^ this is wrong. instead, one must do: . "include/err.sh" err="fail" this is because err is set as a global variable under err.sh the new error handling is much cleaner, and safer. it also reduces the chance of mistakes such as: calling err when you meant to call fail. this is because the standard way is now to call $err, so you set err="fail" at the top of the script and all is well. Signed-off-by: Leah Rowe <leah@libreboot.org>
Diffstat (limited to 'build')
-rwxr-xr-xbuild33
1 files changed, 17 insertions, 16 deletions
diff --git a/build b/build
index 214cec30..38d1694c 100755
--- a/build
+++ b/build
@@ -14,6 +14,7 @@ export LC_ALL=C
. "include/option.sh"
eval "$(setvars "" option aur_notice tmpdir)"
+err="fail"
tmpdir_was_set="y"
set | grep TMPDIR 1>/dev/null 2>/dev/null || tmpdir_was_set="n"
@@ -35,10 +36,10 @@ buildpath="./script/${linkname}"
main()
{
- xx_ id -u 1>/dev/null 2>/dev/null
- [ $# -lt 1 ] && fail "Too few arguments. Try: ${0} help"
+ x_ id -u 1>/dev/null 2>/dev/null
+ [ $# -lt 1 ] && $err "Too few arguments. Try: ${0} help"
- [ "$1" = "dependencies" ] && xx_ install_packages $@ && lbmk_exit 0
+ [ "$1" = "dependencies" ] && x_ install_packages $@ && lbmk_exit 0
for cmd in initcmd check_git check_project git_init excmd; do
eval "${cmd} \$@"
@@ -48,7 +49,7 @@ main()
initcmd()
{
- [ "$(id -u)" != "0" ] || fail "this command as root is not permitted"
+ [ "$(id -u)" != "0" ] || $err "this command as root is not permitted"
check_project
@@ -69,14 +70,14 @@ install_packages()
printf "You must specify a distro, namely:\n" 1>&2
printf "Look at files under config/dependencies/\n" 1>&2
printf "Example: ./build dependencies debian\n" 1>&2
- fail "install_packages: target not specified"
+ $err "install_packages: target not specified"
fi
- [ -f "config/dependencies/${2}" ] || fail "Unsupported target"
+ [ -f "config/dependencies/${2}" ] || $err "Unsupported target"
. "config/dependencies/${2}"
- xx_ ${pkg_add} ${pkglist}
+ x_ ${pkg_add} ${pkglist}
[ -z "${aur_notice}" ] && return 0
printf "You must install AUR packages: %s\n" "$aur_notice" 1>&2
}
@@ -85,24 +86,24 @@ install_packages()
# lbmk can be run from lbmk.git, or an archive.
git_init()
{
- [ -L ".git" ] && fail "Reference .git is a symlink"
+ [ -L ".git" ] && $err "Reference .git is a symlink"
[ -e ".git" ] && return 0
eval "$(setvars "$(date -Rd @${versiondate})" cdate _nogit)"
- git init || fail "${PWD}: cannot initialise Git repository"
- git add -A . || fail "${PWD}: cannot add files to Git repository"
+ git init || $err "${PWD}: cannot initialise Git repository"
+ git add -A . || $err "${PWD}: cannot add files to Git repository"
git commit -m "${projectname} ${version}" --date "${cdate}" \
--author="lbmk <lbmk@libreboot.org>" || \
- fail "$PWD: can't commit ${projectname}/${version}, date $cdate"
+ $err "$PWD: can't commit ${projectname}/${version}, date $cdate"
git tag -a "${version}" -m "${projectname} ${version}" || \
- fail "${PWD}: cannot git-tag ${projectname}/${version}"
+ $err "${PWD}: cannot git-tag ${projectname}/${version}"
}
excmd()
{
lbmkcmd="${buildpath}/${option}"
- [ -f "${lbmkcmd}" ] || fail "Invalid command. Run: ${linkpath} help"
- shift 1; "$lbmkcmd" $@ || fail "excmd: ${lbmkcmd} ${@}"
+ [ -f "${lbmkcmd}" ] || $err "Invalid command. Run: ${linkpath} help"
+ shift 1; "$lbmkcmd" $@ || $err "excmd: ${lbmkcmd} ${@}"
}
usage()
@@ -131,14 +132,14 @@ mkversion()
lbmk_exit()
{
- tmp_cleanup || err "lbmk_exit: can't rm tmpdir upon exit $1: $tmpdir"
+ tmp_cleanup || err_ "lbmk_exit: can't rm tmpdir upon exit $1: $tmpdir"
exit $1
}
fail()
{
tmp_cleanup || printf "WARNING: can't rm tmpdir: %s\n" "$tmpdir" 1>&2
- err "${1}"
+ err_ "${1}"
}
tmp_cleanup()